/*
Copyright (c) 2019-2022 Digital Energy Cloud Solutions LLC. All Rights Reserved.
Authors:
Petr Krutov, <petr.krutov@digitalenergy.online>
Stanislav Solovev, <spsolovev@digitalenergy.online>
Kasim Baybikov, <kmbaybikov@basistech.ru>

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

/*
Terraform DECORT provider - manage resources provided by DECORT (Digital Energy Cloud
Orchestration Technology) with Terraform by Hashicorp.

Source code: https://repository.basistech.ru/BASIS/terraform-provider-decort

Please see README.md to learn where to place source code so that it
builds seamlessly.

Documentation: https://repository.basistech.ru/BASIS/terraform-provider-decort/wiki
*/

package snapshot

import (
	"context"
	"strings"

	"github.com/hashicorp/terraform-plugin-sdk/v2/diag"
	"github.com/hashicorp/terraform-plugin-sdk/v2/helper/schema"
	log "github.com/sirupsen/logrus"
	"repository.basistech.ru/BASIS/decort-golang-sdk/pkg/cloudapi/compute"
	"repository.basistech.ru/BASIS/terraform-provider-decort/internal/constants"
	"repository.basistech.ru/BASIS/terraform-provider-decort/internal/controller"
)

func resourceSnapshotCreate(ctx context.Context, d *schema.ResourceData, m interface{}) diag.Diagnostics {
	log.Debugf("resourceSnapshotCreate: called for snapshot %s", d.Get("label").(string))

	c := m.(*controller.ControllerCfg)
	req := compute.SnapshotCreateRequest{
		Label:     d.Get("label").(string),
		ComputeID: uint64(d.Get("compute_id").(int)),
	}

	snapshotId, err := c.CloudAPI().Compute().SnapshotCreate(ctx, req)
	if err != nil {
		return diag.FromErr(err)
	}

	snapshotId = strings.ReplaceAll(snapshotId, "\"", "")

	d.SetId(snapshotId)
	d.Set("guid", snapshotId)

	return resourceSnapshotRead(ctx, d, m)
}

func resourceSnapshotRead(ctx context.Context, d *schema.ResourceData, m interface{}) diag.Diagnostics {
	snapshot, err := utilitySnapshotCheckPresence(ctx, d, m)
	if err != nil {
		return diag.FromErr(err)
	}

	flattenSnapshot(d, snapshot)

	return nil
}

func resourceSnapshotDelete(ctx context.Context, d *schema.ResourceData, m interface{}) diag.Diagnostics {
	log.Debugf("resourceSnapshotDelete: called for %s, id: %s", d.Get("label").(string), d.Id())

	c := m.(*controller.ControllerCfg)
	req := compute.SnapshotDeleteRequest{
		ComputeID: uint64(d.Get("compute_id").(int)),
		Label:     d.Get("label").(string),
	}

	asyncMode, ok := d.GetOk("delete_async_mode")
	if ok && asyncMode.(bool) {
		_, err := c.CloudAPI().Compute().SnapshotDeleteAsync(ctx, req)
		if err != nil {
			return diag.FromErr(err)
		}
	} else {
		_, err := c.CloudAPI().Compute().SnapshotDelete(ctx, req)
		if err != nil {
			return diag.FromErr(err)
		}
	}

	d.SetId("")

	return nil
}

func resourceSnapshotUpdate(ctx context.Context, d *schema.ResourceData, m interface{}) diag.Diagnostics {
	if d.HasChange("rollback") {
		if d.Get("rollback").(bool) {
			err := resourceSnapshotRollback(ctx, d, m)
			if err != nil {
				return diag.FromErr(err)
			}
		}
	}

	return nil
}

func resourceSnapshotRollback(ctx context.Context, d *schema.ResourceData, m interface{}) error {
	c := m.(*controller.ControllerCfg)
	req := compute.SnapshotRollbackRequest{
		ComputeID: uint64(d.Get("compute_id").(int)),
		Label:     d.Get("label").(string),
	}

	_, err := c.CloudAPI().Compute().SnapshotRollback(ctx, req)
	if err != nil {
		return err
	}
	return nil
}

func resourceSnapshotSchemaMake() map[string]*schema.Schema {
	return map[string]*schema.Schema{
		"compute_id": {
			Type:        schema.TypeInt,
			Required:    true,
			ForceNew:    true,
			Description: "ID of the compute instance to create snapshot for.",
		},
		"label": {
			Type:        schema.TypeString,
			Required:    true,
			ForceNew:    true,
			Description: "text label for snapshot. Must be unique among this compute snapshots.",
		},
		"rollback": {
			Type:        schema.TypeBool,
			Optional:    true,
			Default:     false,
			Description: "is rollback the snapshot",
		},
		"disks": {
			Type:     schema.TypeList,
			Computed: true,
			Elem: &schema.Schema{
				Type: schema.TypeInt,
			},
		},
		"guid": {
			Type:        schema.TypeString,
			Computed:    true,
			Description: "guid of the snapshot",
		},
		"timestamp": {
			Type:        schema.TypeInt,
			Computed:    true,
			Description: "timestamp",
		},
		"delete_async_mode": {
			Type:        schema.TypeBool,
			Computed:    true,
			Description: "async mode",
		},
	}
}

func ResourceSnapshot() *schema.Resource {
	return &schema.Resource{
		SchemaVersion: 1,

		CreateContext: resourceSnapshotCreate,
		ReadContext:   resourceSnapshotRead,
		UpdateContext: resourceSnapshotUpdate,
		DeleteContext: resourceSnapshotDelete,

		Importer: &schema.ResourceImporter{
			StateContext: schema.ImportStatePassthroughContext,
		},

		Timeouts: &schema.ResourceTimeout{
			Create:  &constants.Timeout600s,
			Read:    &constants.Timeout300s,
			Update:  &constants.Timeout300s,
			Delete:  &constants.Timeout300s,
			Default: &constants.Timeout300s,
		},

		Schema: resourceSnapshotSchemaMake(),
	}
}
